import logging

from paircd.client import Client
from paircd.message import Message
from paircd.server import Server


async def handle_nick(server: Server, client: Client, msg: Message) -> None:
    nickname = msg.args[0]

    if client.nickname:
        del server.clients_by_nick[client.nickname]
        # TODO: Update all channel references

    client.nickname = nickname
    server.add_client(client)

    if client.username and client.realname:
        client.registered = True
        logging.info(f"{client.hostname} ({client.id()}) registered")
