import logging

from paircd.client import Client
from paircd.message import Message
from paircd.server import Server


async def handle_user(server: Server, client: Client, msg: Message) -> None:
    if client.registered:
        raise RuntimeError("USER command issued after registration")

    client.username = msg.args[0]
    client.realname = msg.args[3]

    if client.nickname:
        client.registered = True
        logging.info(f"{client.hostname} ({client.id()}) registered")
